OGRE-Next: Ogre::v1::BillboardChain Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
Ogre::v1::BillboardChain Class Reference
Core » Effects

Allows the rendering of a chain of connected billboards. More...

`#include <OgreBillboardChain.h>`

Inheritance diagram for Ogre::v1::BillboardChain:
[legend]

## Classes
class | Element
| Contains the data of an element of the BillboardChain. More...

## Public Types
typedef vector< Element >::type | ElementList
enum | TexCoordDirection { TCD_U , TCD_V }
| The direction in which texture coordinates from elements of the chain are used. More...
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap

## Public Member Functions
| BillboardChain (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, size_t maxElements=20, size_t numberOfChains=1, bool useTextureCoords=true, bool useColours=true, bool dynamic=true)
| Constructor (don't use directly, use factory)
| ~BillboardChain () override
| Destructor.
void | _updateRenderQueue (RenderQueue *, Camera *camera, const Camera *lodCamera) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
virtual void | addChainElement (size_t chainIndex, const Element &billboardChainElement)
| Add an element to the 'head' of a chain.
virtual void | clearAllChains ()
| Remove all elements from all chains (but leave the chains themselves intact).
virtual void | clearChain (size_t chainIndex)
| Remove all elements of a given chain (but leave the chain intact).
const AxisAlignedBox & | getBoundingBox () const
virtual const Element & | getChainElement (size_t chainIndex, size_t elementIndex) const
| Get the detail of a chain element.
virtual bool | getDynamic () const
| Gets whether or not the buffers created for this object are suitable for dynamic alteration.
const LightList & | getLights () const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
virtual size_t | getMaxChainElements () const
| Get the maximum number of chain elements per chain.
const String & | getMovableType () const override
| Returns the type name of this object.
virtual size_t | getNumberOfChains () const
| Get the number of chain segments (this class can render multiple chains at once using the same material).
virtual size_t | getNumChainElements (size_t chainIndex) const
| Returns the number of chain elements.
virtual const Real * | getOtherTextureCoordRange () const
| Get the range of the texture coordinates generated across the width of the chain elements.
void | getRenderOperation (RenderOperation &, bool casterPass) override
| Gets the render operation required to send this object to the frame buffer.
Real | getSquaredViewDepth (const Camera *cam) const
virtual TexCoordDirection | getTextureCoordDirection ()
| Gets the direction in which texture coords specified on each element are deemed to run.
virtual bool | getUseTextureCoords () const
| Gets whether texture coordinate information should be included in the final buffers generated.
virtual bool | getUseVertexColours () const
| Gets whether vertex colour information should be included in the final buffers generated.
void | getWorldTransforms (Matrix4 *) const override
| Gets the world transform matrix / matrices for this renderable object.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys) override
| Called just prior to the Renderable being rendered.
virtual void | removeChainElement (size_t chainIndex)
| Remove an element from the 'tail' of a chain.
virtual void | setDynamic (bool dyn)
| Sets whether or not the buffers created for this object are suitable for dynamic alteration.
void | setFaceCamera (bool faceCamera, const Vector3 &normalVector=Vector3::UNIT_X)
| Sets whether the billboard should always be facing the camera or a custom direction set by each point element.
virtual void | setMaxChainElements (size_t maxElements)
| Set the maximum number of chain elements per chain.
virtual void | setNumberOfChains (size_t numChains)
| Set the number of chain segments (this class can render multiple chains at once using the same material).
virtual void | setOtherTextureCoordRange (Real start, Real end)
| Set the range of the texture coordinates generated across the width of the chain elements.
virtual void | setTextureCoordDirection (TexCoordDirection dir)
| Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.
virtual void | setUseTextureCoords (bool use)
| Sets whether texture coordinate information should be included in the final buffers generated.
virtual void | setUseVertexColours (bool use)
| Sets whether vertex colour information should be included in the final buffers generated.
virtual void | updateChainElement (size_t chainIndex, size_t elementIndex, const Element &billboardChainElement)
| Update the details of an existing chain element.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only)
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only)
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum()
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum()
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

Allows the rendering of a chain of connected billboards.

Remarks
  A billboard chain operates much like a traditional billboard, i.e. its segments always face the camera; the difference being that instead of a set of disconnected quads, the elements in this class are connected together in a chain which must always stay in a continuous strip. This kind of effect is useful for creating effects such as trails, beams, lightning effects, etc.

  A single instance of this class can actually render multiple separate chain segments in a single render operation, provided they all use the same material. To clarify the terminology: a 'segment' is a separate sub-part of the chain with its own start and end (called the 'head' and the 'tail'). An 'element' is a single position / colour / texcoord entry in a segment. You can add items to the head of a chain, and remove them from the tail, very efficiently. Each segment has a max size, and if adding an element to the segment would exceed this size, the tail element is automatically removed and re-used as the new item on the head.

  This class has no auto-updating features to do things like alter the colour of the elements or to automatically add / remove elements over time - you have to do all this yourself as a user of the class. Subclasses can however be used to provide this kind of behaviour automatically.

See also
  RibbonTrail

## Member Typedef Documentation

## ◆ ElementList

typedef vector<Element>::type Ogre::v1::BillboardChain::ElementList

## Member Enumeration Documentation

## ◆ TexCoordDirection

enum Ogre::v1::BillboardChain::TexCoordDirection

The direction in which texture coordinates from elements of the chain are used.

Enumerator
TCD_U | Tex coord in elements is treated as the 'u' texture coordinate.
TCD_V | Tex coord in elements is treated as the 'v' texture coordinate.

## Constructor & Destructor Documentation

## ◆ BillboardChain()

Ogre::v1::BillboardChain::BillboardChain | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager,
|  | size_t | maxElements = 20,
|  | size_t | numberOfChains = 1,
|  | bool | useTextureCoords = true,
|  | bool | useColours = true,
|  | bool | dynamic = true )

Constructor (don't use directly, use factory)

Parameters

  name | The name to give this object
  maxElements | The maximum number of elements per chain
  numberOfChains | The number of separate chain segments contained in this object
  useTextureCoords | If true, use texture coordinates from the chain elements
  useColours | If true, use vertex colours from the chain elements
  dynamic | If true, buffers are created with the intention of being updated

## ◆ ~BillboardChain()

Ogre::v1::BillboardChain::~BillboardChain | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ _updateRenderQueue()

void Ogre::v1::BillboardChain::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera )
| overridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Reimplemented from Ogre::MovableObject.

## ◆ addChainElement()

virtual void Ogre::v1::BillboardChain::addChainElement | ( | size_t | chainIndex,
|  | const Element & | billboardChainElement )
| virtual

Add an element to the 'head' of a chain.

Remarks
  If this causes the number of elements to exceed the maximum elements per chain, the last element in the chain (the 'tail') will be removed to allow the additional element to be added.

Parameters

  chainIndex | The index of the chain
  billboardChainElement | The details to add

## ◆ clearAllChains()

virtual void Ogre::v1::BillboardChain::clearAllChains | ( |  | ) |
| virtual

Remove all elements from all chains (but leave the chains themselves intact).

## ◆ clearChain()

virtual void Ogre::v1::BillboardChain::clearChain | ( | size_t | chainIndex | ) |
| virtual

Remove all elements of a given chain (but leave the chain intact).

Reimplemented in Ogre::v1::RibbonTrail.

## ◆ getBoundingBox()

const AxisAlignedBox & Ogre::v1::BillboardChain::getBoundingBox | ( |  | ) | const

## ◆ getChainElement()

virtual const Element & Ogre::v1::BillboardChain::getChainElement | ( | size_t | chainIndex,
|  | size_t | elementIndex ) const
| virtual

Get the detail of a chain element.

Parameters

  chainIndex | The index of the chain
  elementIndex | The element index within the chain, measured from the 'head' of the chain

## ◆ getDynamic()

virtual bool Ogre::v1::BillboardChain::getDynamic | ( |  | ) | const
| inlinevirtual

Gets whether or not the buffers created for this object are suitable for dynamic alteration.

## ◆ getLights()

const LightList & Ogre::v1::BillboardChain::getLights | ( |  | ) | const
| overridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getMaxChainElements()

virtual size_t Ogre::v1::BillboardChain::getMaxChainElements | ( |  | ) | const
| inlinevirtual

Get the maximum number of chain elements per chain.

## ◆ getMovableType()

const String & Ogre::v1::BillboardChain::getMovableType | ( |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

Reimplemented in Ogre::v1::RibbonTrail.

## ◆ getNumberOfChains()

virtual size_t Ogre::v1::BillboardChain::getNumberOfChains | ( |  | ) | const
| inlinevirtual

Get the number of chain segments (this class can render multiple chains at once using the same material).

## ◆ getNumChainElements()

virtual size_t Ogre::v1::BillboardChain::getNumChainElements | ( | size_t | chainIndex | ) | const
| virtual

Returns the number of chain elements.

## ◆ getOtherTextureCoordRange()

virtual const Real * Ogre::v1::BillboardChain::getOtherTextureCoordRange | ( |  | ) | const
| inlinevirtual

Get the range of the texture coordinates generated across the width of the chain elements.

## ◆ getRenderOperation()

void Ogre::v1::BillboardChain::getRenderOperation | ( | RenderOperation & | op,
|  | bool | casterPass )
| overridevirtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ getSquaredViewDepth()

Real Ogre::v1::BillboardChain::getSquaredViewDepth | ( | const Camera * | cam | ) | const

## ◆ getTextureCoordDirection()

virtual TexCoordDirection Ogre::v1::BillboardChain::getTextureCoordDirection | ( |  | ) |
| inlinevirtual

Gets the direction in which texture coords specified on each element are deemed to run.

## ◆ getUseTextureCoords()

virtual bool Ogre::v1::BillboardChain::getUseTextureCoords | ( |  | ) | const
| inlinevirtual

Gets whether texture coordinate information should be included in the final buffers generated.

## ◆ getUseVertexColours()

virtual bool Ogre::v1::BillboardChain::getUseVertexColours | ( |  | ) | const
| inlinevirtual

Gets whether vertex colour information should be included in the final buffers generated.

## ◆ getWorldTransforms()

void Ogre::v1::BillboardChain::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

Gets the world transform matrix / matrices for this renderable object.

Remarks
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate transform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also
  Matrix4::isAffine.

Implements Ogre::Renderable.

## ◆ preRender()

virtual bool Ogre::v1::BillboardChain::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys )
| overridevirtual

Called just prior to the Renderable being rendered.

Remarks
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented from Ogre::Renderable.

## ◆ removeChainElement()

virtual void Ogre::v1::BillboardChain::removeChainElement | ( | size_t | chainIndex | ) |
| virtual

Remove an element from the 'tail' of a chain.

Parameters

  chainIndex | The index of the chain

## ◆ setDynamic()

virtual void Ogre::v1::BillboardChain::setDynamic | ( | bool | dyn | ) |
| virtual

Sets whether or not the buffers created for this object are suitable for dynamic alteration.

## ◆ setFaceCamera()

void Ogre::v1::BillboardChain::setFaceCamera | ( | bool | faceCamera,
|  | const Vector3 & | normalVector = Vector3::UNIT_X )

Sets whether the billboard should always be facing the camera or a custom direction set by each point element.

Remarks
  Billboards facing the camera are useful for smoke trails, light beams, etc by simulating a cylinder. However, because of this property, wide trails can cause several artefacts unless the head is properly covered. Therefore, non-camera-facing billboards are much more convenient for leaving big trails of movement from thin objects, for example a sword swing as seen in many fighting games.

Parameters

  faceCamera | True to be always facing the camera (Default value: True)
  normalVector | Only used when faceCamera == false. Must be a non-zero vector. This vector is the "point of reference" for each point orientation. For example, if normalVector is Vector3::UNIT_Z, and the point's orientation is an identity matrix, the segment corresponding to that point will be facing towards UNIT_Z This vector is internally normalized.

References Ogre::Vector3::UNIT_X.

## ◆ setMaxChainElements()

virtual void Ogre::v1::BillboardChain::setMaxChainElements | ( | size_t | maxElements | ) |
| virtual

Set the maximum number of chain elements per chain.

Reimplemented in Ogre::v1::RibbonTrail.

## ◆ setNumberOfChains()

virtual void Ogre::v1::BillboardChain::setNumberOfChains | ( | size_t | numChains | ) |
| virtual

Set the number of chain segments (this class can render multiple chains at once using the same material).

Reimplemented in Ogre::v1::RibbonTrail.

## ◆ setOtherTextureCoordRange()

virtual void Ogre::v1::BillboardChain::setOtherTextureCoordRange | ( | Real | start,
|  | Real | end )
| virtual

Set the range of the texture coordinates generated across the width of the chain elements.

Parameters

  start | Start coordinate, default 0.0
  end | End coordinate, default 1.0

## ◆ setTextureCoordDirection()

virtual void Ogre::v1::BillboardChain::setTextureCoordDirection | ( | TexCoordDirection | dir | ) |
| virtual

Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.

Parameters

  dir | The direction, default is TCD_U.

## ◆ setUseTextureCoords()

virtual void Ogre::v1::BillboardChain::setUseTextureCoords | ( | bool | use | ) |
| virtual

Sets whether texture coordinate information should be included in the final buffers generated.

Note
  You must use either texture coordinates or vertex colour since the vertices have no normals and without one of these there is no source of colour for the vertices.

## ◆ setUseVertexColours()

virtual void Ogre::v1::BillboardChain::setUseVertexColours | ( | bool | use | ) |
| virtual

Sets whether vertex colour information should be included in the final buffers generated.

Note
  You must use either texture coordinates or vertex colour since the vertices have no normals and without one of these there is no source of colour for the vertices.

## ◆ updateChainElement()

virtual void Ogre::v1::BillboardChain::updateChainElement | ( | size_t | chainIndex,
|  | size_t | elementIndex,
|  | const Element & | billboardChainElement )
| virtual

Update the details of an existing chain element.

Parameters

  chainIndex | The index of the chain
  elementIndex | The element index within the chain, measured from the 'head' of the chain
  billboardChainElement | The details to set

The documentation for this class was generated from the following file:

- OgreBillboardChain.h